\documentclass[a4paper, twoside]{scrartcl}

%% Language and font encodings
\usepackage[english]{babel}
\usepackage[utf8x]{inputenc}
\usepackage{graphicx}
\usepackage{float}
\usepackage[T1]{fontenc}
\usepackage{tikz}
\usepackage{biblatex}
\addbibresource{Bibliography.bib}
\usepackage{comment}
\usepackage{blindtext}
\usepackage{fancyhdr}
\usepackage[toc,page]{appendix}
\usepackage{listings}
\usepackage{colortbl,hhline}
% Turn on the style
\pagestyle{fancy}
% Clear the header and footer
\fancyhead{}
\renewcommand{\headrulewidth}{0pt}
\fancyfoot{}
% Set the right side of the footer to be the page number
\fancyfoot[R]{\thepage}

%% Sets page size and margins
\usepackage[a4paper,top=2cm,bottom=3cm,left=2cm,right=2cm,marginparwidth=1.75cm]{geometry}

%% Useful packages
\usepackage{amsmath}
\usepackage{graphicx}


\title{Automatic vegetable growing for future long-term space missions}
\author{Gabriela Catalán, Adrien Mencik}
% Update supervisor and other title stuff in title/title.tex

\begin{document}

\newgeometry{top=1.0526cm,bottom=1.0606cm,left=1.7526cm,right=1.7526cm}
\input{first.tex}
\restoregeometry

\begin{center}
Declaration of Authenticity
\end{center}

This assignment is entirely my own work. Quotations from literature are properly indicated with appropriated references in the text. All literature used in this piece of work is indicated in the bibliography placed at the end. I confirm that no sources have been used other than those stated. 
\\
\\
\\
\\
I understand that plagiarism (copy without mentioning the reference) is a serious examinations offense that may result in disciplinary action being taken.
\\
\\
\\
\\
Date: 22 june 2020						
\\
\\
Signature: Gabriela Catalán, Adrien Mencik

\newpage
\tableofcontents

\newpage
\section{Abstract}
Keywords: machine learning, MDP framework, artificial intelligence, hydroponics, Mars, space  
\\
\\
\\
\\
In recent history, Nasa and ESA, among other agencies, have been analyzing two priorities of present and future long term missions in space: the reduction of the teams' workload, and the food supply. This project tackles these issues by proposing an autonomous efficient growing plant systems based on arugula. Using an nutrient filled hydroponic technique, an arm robot, the image recognition algorithm Overfeat, OpenCV, Python-tesseract and a Markov Decision Process environment, decisions will be taken in order to minimize resources consumption and the amount of space taken. A prototype will be constructed and the algorithms tested and optimized. The second stage of the project will consist in analyzing a greater amount of plants as well as isolating the system from ambient conditions.   

\newpage
\section{Introduction}
Present and future space missions clarify two priorities: the reduction of the teams' workload, and the food supply.
Indeed, as "human space exploration helps to address fundamental questions about our place in the Universe and the history" \cite{NasaIntro}, and as, taking the ISS as example, "at any given time on board the space station, a large array of different experiments are underway within a wide range of disciplines" \cite{NasaIntro2}, the workload induced by tasks lacking relation with the ongoing experiments, such as everyday tasks, must be lessened. 
\\
\\
Furthermore, as future space missions are expected to last an increasing amount of time, food supply will become an important issue to address. Inboard plant growing, through its cost and space-efficiency, constitutes a viable solution to that problem.
\\
\\
As plant growing can also be pointed out as one of the most time consuming and repetitive daily task, this Master thesis presents a way to automate the growing of plants in space. 
\\
\\
Using a new growing process based on AI tools, the team worked on an autonomous prototype capable of analyzing and reacting to the growing process. The goal of this technique if to optimize resources, save space, maximize the plants' well being and reduce the time of growth compared to soil based methods.
In this project, a plant growing system is set up. Its purposes include to test growing strategies using artificial intelligence (planning under uncertainty and machine learning), as well as to achieve an implementation on real robotic systems. In order to do so, a Markov decision process based algorithm will be created, enhanced by image recognition.
\\
\\
In summary, the goals of the project are: 
\begin{itemize}
    \item To establish a state of the art of vegetable growing systems.
    \item Given the constraints identified, to produce an autonomous prototype able to analyze and react to the growing process.
    \item To propose an experimental setup and its implementation (graphical interface, data recording, etc.)
    \item To set up an optimization strategy and to deploy growing strategies for the platform.
\end{itemize}
\newpage

\section{Semester 2 section}
\subsection{Context and key issues}
\subsubsection{Context}
John Glenn was the first American to consume food in space, aboard Friendship 7's space capsule in 1962. As it was not known at that time if "ingestion and absorption of nutrients were possible in a state of zero gravity" \cite{NasaEating}, Glenn demonstrated that people could eat, swallow, and digest food in space environment.
Every space mission that followed, from Gemini to recent ISS' space missions, through Skylab and Apollo-Soyuz Program Food, space food has always been brought from earth. 
However, as space missions are becoming longer and weight saving is more than ever important, bringing supply from earth will no longer constitute the best option. As resupply from Earth will be too expensive both in terms of energy and time, this project will tackle the exploration of plant growing in space, combined with the automation of the system to reduce the workload of the crew. 

\subsubsection{Issues}
The issues that rise when trying to grow vegetables autonomously in a spaceship or on an hostile ground such as Mars are the lack of space, nutrients, water, gravity and oxygen \cite{Mars}. 
\\
\\
About Mars, scientists have conducted plant experiments simulating Martian conditions using volcanic soil in Hawaii, which is known for its similarity to Martian soil. The results of these experiments have shown that plants can actually grow in these soils. More than that, watering plants on Mars could require less water than on Earth, as the gravity is 3 times lower, leading to a better hold of the soil and of nutrients, as they would drain slower than on Earth \cite{SpaceFood}.
Instead, the main issue faced on Mars and on most places in the universe is the temperature. As seen in the movie "The martian", \cite{Martian}, crops that are exposed to Martian's conditions of temperatures averaging minus 60 degrees, will immediately freeze and die. 
This leads to no other choice than to grow vegetables within a controlled area, bringing back the issues faced during space missions in spaceships: the limitation of resources and space. 
The choice of the growing method can thus be made for both applications and must be chosen as to consume the least space, nutrient and water possible. 
\\
\\
Regarding the implementation of this solution, one issue faced for the prototype is the conjunction of all its components together. Indeed, since the solution will juggle with a huge amount of information coming from a lot of sensors, the debugging process is expected to be very complicated.
On top of that, as the project is carried throughout the year 2020 and in France, it has been facing some issues raised by the reaction to the COVID-19 virus, and more specifically the general confinement in France and around the world. 
The delay of arrival of the components ordered, as well as the lack of access to the campus in order to work on the parts that have arrived formed the main project issues, which led to the delay of the construction of the physical prototype. 
Following this unexpected situation, the experiments were chosen to be conducted virtually, as all approximations, measures and thus inputs and outputs have been estimated. 
However if the command turned out not to arrive before the end of the allowed time to work on the project, databases of plants have been found on internet and will be used to simulate the real problem that we are facing.
On top of that, a small crop has been realized, on which part of the experiments will be conducted and compared with the results provided using the databases. 
The final issue is the lack of growing expertise of the team. The plant type chosen will be selected as easy to grow to tackle this problem. 
\begin{comment}
Think also about difficulties that may occur (expertise on growing things? technical issues? What happen if no command arrive? (show that you have always planB, and so on on intermediary reports - here... do simulations for example. but also, research questions: what's difficult when autonomously growing things - and even more on Mars ?
\end{comment}
\subsection{State of the Art}
The state of the art constructed for this project focuses on establishing what has been discovered and what is currently under research in the fields of indoor agriculture, robotics and machine learning.

\subsubsection{Indoor agriculture: what is currently under research and what has been done in the past}
Starting in 2012, NASA has been analyzing a solution to the challenge of growing plants in space. The agency has established that "using soil for this purpose may not work due to its weight, the problem of particles floating about in zero gravity, and the potential for harboring health-threatening germs" \cite{NasaHydro}. To address this issue, NASA has focused on developing hydroponic methods of growing plants in space. Since 2016, the agency has been studying by the means of intensive testing the comportment of plants grown using a hydroponic system. It has developed an analyzer that provides real-time detection of nutrients, organics, and metals in water \cite{NasaHydro2}.
\\
\\
The European Space Agency (ESA) stated in 2010 that "cultivating plants for food was a significant step in the history of mankind. Growing plants for food in space and on other planets will be necessary for exploration of our Universe" \cite{esa2}. Following that statement, ESA has been collaborating with EnginSoft to "investigate hydroponic plant growth for future space missions" \cite{ESAhydro}. 
This project’s main efforts concern "the life support system sector and the idea of creating an artificially closed ecosystem that generates food and oxygen for space crews on long-term missions". A prototype capable of cultivating 100 plants and investigate their growth process has been built, located at the Universitat Autònoma de Barcelona.
\\
\\
Globally, out of all discovered indoor plant agriculture processes, 3 main methods are of interest:
\begin{itemize}
        \item soil based growth.
        \item hydroponic growth.
        \item aeroponic growth.
\end{itemize}
\noindent    
Soil based growth have been exploited since the beginning of human's history. Today, after numerous studies, it has been established that the ideal blend of soil for plant growth is loam, a mixture of sand, clay, and silt. \cite{Soil}
\\
\\
The earliest examples of hydroponics date back to the Hanging Gardens of Babylon and the Floating Gardens of China, thousand of years ago. \cite{Histhydro}. However, modern hydroponics have begun to be used around the years 1950. Recently, the largest hydroponic farm, built in the USA, produces 2 million pounds of lettuce per year \cite{Histhydro2}. Hydroponic growth presents the advantages of using up to 90 \% less water than a traditional soil growth, as water is recirculated and of making better use of space and location. Indeed, the plants’ roots usually expand and spread out in search of foods and oxygen in the soil. This is not the case in hydroponics, where the roots are sunk in a PH controlled tank filled with an oxygenated nutrient solution and directly put in contact with vital minerals \cite{Hydroponics}. The plants can grow much closer, enabling huge space savings. On top of that, hydroponic growing systems have a 100\% control of the nutrients that plants need, with the consequence of better growth rate and a maximization of the plant well-being, without being as complex to implement compared to aeroponic systems. It has the inconvenience of an heavy maintenance: plants will die out quickly without proper care and adequate knowledge. Concerns about whether  plants  grown  hydroponically  will  get  microbiomes have also been raised, with no concrete evidence at this time \cite{sheridan2017microbial}.
\\
\\
The nutrient film technique \cite{Soilless}, a sub-part of hydroponics growth system is of particular interest. This simple and efficient method is largely used in all over the world. Its key advantage is power saving, as gravity is used to stimulate the flow of water and nutrients, lessening the effort induced on the pump.
\\
\\
Aeroponics systems present a lower consumption of resources than hydroponics'. Indeed, the method uses a small micro-jet spray that feeds the roots of the plant with a high pressure water containing nutrient rich solutions.
Because the roots are exposed to more oxygen, aeroponics also have the advantage of a fast growth. The technique also requires little place.

Nonetheless, as a typical aeroponics system is made up of high pressure pumps, sprinklers and timers, it has a high level of complexity. In addition, plants can be damaged or killed easily if any if the components were to fail. Precise knowledge of nutrients amounts required by the plant is also essential. The technique requires regular cleaning and disinfection as well. The system is very complex and has a high cost \cite{Aeroponics}. 
\\
\\
The state of the art focused also on the different humanly eatable vegetable to grow. Arugula is the fastest and easiest vegetable to harvest\cite{Arugula}, and has similar characteristics between low and normal gravity conditions \cite{Arugula2}, .
\\
\\
Based on the presented criteria, both the hydroponic system and arugula have been selected. 

\subsubsection{Automation of system and machine learning strategies: what is currently under research and what has been done in the past}
AI planning has made major steps forward in terms of the size and
difficulty of problems that can be solved \cite{MDP11}. Different recent methods for AI planning are commonly in use. The following non exhaustive list relates the most interesting ones \cite{MDPList}.  

\begin{itemize}
    \item Classical planning is the most common AI planning strategy. Its characteristics are:
        \begin{itemize}
    \item dynamics: deterministic
    \item goal: satisfiability
    \item observability : full
    \item horizon : finite
\end{itemize}
    \item Fully Observable Non-Deterministic (FOND) planning: 
        \begin{itemize}
    \item dynamics: non-deterministic
    \item goal: satisfiability
    \item observability : full
    \item horizon : finite or infinite
\end{itemize}
    \item Partially Observable Non-Deterministic (POND): planning
        \begin{itemize}
    \item dynamics: non-deterministic
    \item goal: satisfiability
    \item observability : partial
    \item horizon : finite or infinite
\end{itemize}
    \item Markov Decision Process (MDP):
        \begin{itemize}
    \item dynamics: probabilistic
    \item goal: optimization
    \item observability : full
    \item horizon : finite or infinite
\end{itemize}
    \item Partially Observable MDP (POMDP)
        \begin{itemize}
    \item dynamics: probabilistic
    \item goal: optimization
    \item observability : partial
    \item horizon : finite or infinite
\end{itemize}
\end{itemize}
\noindent
The resolution of MDP is characterized by the resolution of the non linear Bellman Optimality Equation \cite{MDPcours2}. The equation being non linear, there is no closed form solution in general and techniques must be used to solve the problem by iteration \cite{MDPcours}, such as: 
\begin{itemize}
    \item value iteration
    \item policy iteration
    \item Q-learning
    \item Sarsa
\end{itemize}

\subsubsection{Image recognition}

Different image recognition algorithms exist. To start describing image recognition, two terms must be explained before going further: computer vision (CV) and image recognition. The aim of the first one is to let a computer visualize an image and take action. On the other hand the second term involves pixel and pattern analysis of an image to recognize it as a particular object.\\


\noindent Understanding the content of an image involves automated extracting of information. Information can differ from camera position, object detection and recognition to grouping and searching image content \cite{CVP}. 3 main types of information have to be extracted from plants in order to fulfill all machine learning environment requirements:
\begin{itemize}
    \item Detection of the plant.
    \item Detection of greenness of the plant.
    \item Detection of the height of the plant
\end{itemize}

\noindent For these purposes, different algorithms are investigated such as classifiers, color detection algorithms and optical character recognition.\\

\noindent The image classification has been an active research area since the development of computer vision, and many classical and deep learning approaches have been applied in this field. Particularly, similar to many other fields in computer vision, deep learning approaches using neural network have achieved significant success in tackling object classification, localization, and detection.\cite{brownlee2019deep}\\

\noindent In some approaches presented before, given an input image of pixels, the hand-defined algorithm is applied and returns a feature vector quantifying the image contents (i.e., shape, texture, color, etc). The image pixels themselves did not serve any other purpose than being inputs to the feature extraction process.\\

\noindent Convolutional Neural Networks take a different approach. Instead of hand-defining a set of rules and algorithms to extract features from an image, the features are automatically learned from the training process \cite{rosebrock2017deep}. This approach uses machine learning strategies in order to achieve the goal. This kind of method is considered as the most optimum, not taking aside the efficiency of databases from which these algorithms are trained.\\
\newpage
\begin{figure}[h]
    \centering
    \includegraphics[width=0.7\textwidth,height=6cm ]{Images/conv.png}
    \caption{Convolutional Neural Networks}
    \label{fig:figure8}
\end{figure}

\noindent Numerous algorithms based on Convolutional Neural Networks have been developed recently. The most accurate ones are tested in the contest of ImageNet Large Scale Visual Recognition Challenge, and only the ones that have most innovative approach using CNN are presented. They are: \\

\begin{itemize}
    \item Overfeat: Presents a multi-scale and sliding window approach that can be efficiently implemented within a Convolutional Network. Bounding boxes are accumulated rather than suppressed in order to increase detection confidence. These configurations allow different task to be learned simultaneously using a single shared network \cite{overfeat}.
    \item VGG16 & VGG19: Confer a new contribution by investigating the effect of the CNN depth on its accuracy in the large-scale image recognition, showing significant improvement on the prior-art configurations can be achieved by pushing the depth to 16-19 weight layers \cite{vgg}.
    \item ResNet50: Presents a residual learning framework to have easier training models which have deeper CNN as the ones of VGG allowing the use of less complex neural networks.  \cite{res}
\end{itemize}

\noindent Although, not only the accuracy can tell if an algorithm works properly or not, there are some other key points that help to conclude on the most adequate algorithm's behavior in actual conditions of the project, such as the resources available (RAM consumption for example).

\noindent In terms of the color detection, some classification algorithms, such as overfeat, made an implementation of showing the features of an image that was processed. However, the algorithm is less efficiently showing this kind of information. The computation time increases as the feature extraction contains a large amount of unnecessary information.\\

\noindent By contrast some other Python open sources libraries such as OpenCV offer a large variety of modules in order to achieve this color detection on the plant images in the most efficient way possible.\\

\noindent OpenCV itself has played a role in the growth of computer vision by enabling thousands of people work on it together \cite{open}. OpenCV is being used by giant companies like Google and IBM. It gives users assurance that they use a library that is being used extensively and is always kept updated thanks to the large community that also enhance a better comprehension of the library and its features.\\

\noindent Moreover this library has been deployed in order to provide algorithmic efficiency, where its design allows you to implement programs with hardware acceleration.\\

\noindent For the Optical Character Recognition, as the classification part, the determination of the best character recognition algorithm highly depends on the image and the noise around the image (objects which are not characters). Therefore, taking into account these conditions, Tesseract is one of the most powerful character recognition in this field. Google uses this algorithm in order to make its text predictions, proving its efficiency.\\

This algorithm works better in a single line without a lot of noise around the image, therefore it is recommended to implement this algorithm with other ones as text detectors \cite{sommer2010outside}, or just crop the image if you know the exact position of the text. Therefore the best configuration is to work with this algorithm in conjunction with OpenCV.










\subsection{Justification of the potential degree of novelty}

Both ESA and NASA currently have plans to grow fruits and vegetables on space farms, but no actual prototypes have been released publicly and no tests have been made in actual space. This project wants to provide a viable autonomous solution to these plans, with the addition of testing it in conditions approaching space environment at the highest level possible.
\\
\\
In addition the top-down approach applied during this experiment to the system conditions could lead to an innovative space research approach, starting with normal conditions and ending up with a total isolation of the system. All conditions can be tested separately in order to find the best solution.
\\
\\
On top of that, the project tackles the issue of the current agriculture productivity. Indeed, as the main constraints of the selected autonomous prototype are to consume the least amount of resources possible while maximizing the plant's health, the solution that it will provide could be the basis of an entire new practice that can increase the world's global agricultural efficiency. 
\\
\\
Hydroponic processes can be considered as the future best agricultural solution for both space and earth environment, confirming the high degree of novelty of the project. 
\subsection{Aims and objectives}

The project is divided into three main stages: 
         \begin{itemize}
             \item The first stage which consists in: 
             \begin{itemize}
                \item Establishing a state of the art around the topic of both agriculture of plants and optimization strategies. 
                \item Fixing the constrains of the project.
                \item Focusing on the growth of one type of plant only, and with a limited number of recoverable data. 
                \item Finding an automatic solution to move around the plants in their pots, and implement a code regulating its behavior. 
                \item Choosing the best machine learning strategy to lead the overall system to a maximization of the plant's speed of growth and overall well-being, and put it into action by the intermediate of a code. 
                \item Building a functional prototype of the hydroponic system.
             \end{itemize}
             \item The second stage of the project: 
            \begin{itemize}
                \item Growing a larger variety of plants.
                \item Adding a reserve tank to the hydroponic system.
                \item Increasing the amount of recoverable data in order to optimize the overall system even more. 
            \end{itemize}
            \item The third stage of the project: 
            \begin{itemize}
                \item Isolating the system from ambient conditions.
                \item Providing an individual enlightenment to each plant. 
            \end{itemize}
         \end{itemize}
        
\noindent
Considering the long delay of order, the start of the project consists in the establishment of a state of the art concerning the different solutions of plant agriculture. The best solution applicable to the project must be set and the ordering of the components completed.
\\
\\
By the end of S2, the expectations are to complete a substantial part of the first stage of the project. A plan of a prototype matching the project's goal is to be established, and the different components composing it to be ordered. Following the receiving of these components, the prototype is set to be built for the end of S2. 
\\
The state of the art of machine learning strategies as well as different automatic solutions, and the following implementation to our prototype was set to be realized during S3.

\subsection{Changes to the original plan}
{Following the beginning of the period of confinement, it was decided to focus on the finding of literature and analysis of machine learning strategies and image recognition algorithm. The actual build process of the prototype is delayed to S3, as well as the experiments, to the benefit of the virtual application of the strategies}

\section{Investigation Methods}

All choices presented in the next section have been made based on the information provided in the state of the art. 
The investigation methods that concern the debugging and optimization of all machine learning strategies implementation and control of equipment, need a prototype for them to be tested. This section will thus cover the realization process of this prototype, in order to enable investigation of the potential optimization lead and debugging of the methods presented in the next section.   
\subsection{The prototype}
{A plant growing system has been designed. The manual realization process of the system was predicted to last approximately 3 months. A end of build limit date was set to the end of June 2020, but as been modified since the delivery date of its components has been extended. 
\\
\\
A plan of the system has nevertheless been made, combined which the choices that characterize it. 
The following list summaries all that has been done, following the completion of a state of the art. 

\begin{itemize}
    \item The type of plant suiting the best our experiments and the goal of the project has been selected. Radish, leaf lettuce, spinach, baby carrots were taken into account, but arugula was the best plant to go for. The decision was taken after discussions with Mason Edgar, a PhD in sciences at the Ecology Institute of the Autonomous University of Mexico, and after research. It is proven that plant is one of the most nutritive plants of its category \cite{Arugula} and has a faster growth than any other vegetable. 
    \item An investigation of the mean of growth of the plants has been made. The hydroponic system has been selected. 
    \item A deeper study of the system lead to the sub selection of the NFT hydroponic system. The final prototype consists of two tanks with nutrients, one to feed all the system and the other one to fill the general tank when empty. Two water pumps connected to a controller system are needed in order to control the water flow of the trays \cite{hydroponic}. Figure \ref{fig:growing sys} shows the global design of the prototype.

\\
\\
\begin{figure}[h]
    \centering
    \includegraphics[width=0.4\textwidth,height=6cm ]{Images/general.png}
    \caption{Plant growing system}
    \label{fig:growing sys}
\end{figure}
    
    \item In addition to the hydroponic system, an electrical system, seen on figure \ref{fig:elec}, had to be designed in order to keep track of the growth of the plants, get data and act on the system. To that goal, a robotic arm is selected: the PiArm. It is equipped with a camera that will provide data corresponding to the growth of the plants, and can move on one axis thanks to the rail that supports it, as shown on figure \ref{fig:sys}. The robotic arm is able to plant and harvest by itself all the plants that are fully grown. Sensors will be used in order to evaluate the water level, temperature and PH. These are the devices that will give the inputs and outputs of the system, allowing the knowledge and acting on the state of the plant.
    \begin{figure}[H]
    \centering
    \includegraphics[width=0.3\textwidth]{Images/robot.png}
    \caption{The PiArm, fixed on its rail}
    \label{fig:sys}
    \end{figure}
    \begin{figure}[h]
    \centering
    \includegraphics[width=0.7\textwidth]{Images/Rob.png}
    \caption{Electrical scheme of the system}
    \label{fig:elec}
\end{figure}

    The possible outputs are: 
    \begin{itemize}
        \item The images taken by the camera.
        \item The ambient temperature, given by the temperature sensor.
        \item The PH level of the water, given by the PH sensor.
        \item The water flow, given by the water flow sensor.
        \item The temperature, given by the temperature sensor.
    \end{itemize}
    The inputs are:
    \begin{itemize}
        \item Acting on the flow of water and nutrients level, via the water pump and controller.
        \item Acting on the temperature by moving the source of light. 
        \item Removing the plant, using the robot.
    \end{itemize}

\item The quotes for every components of the system have been requested and received. 
\item The system is ordered and the team is waiting for the parts to arrive. 
\item The analysis of the type of control systems possible to be added to our automatic hydroponic system ins done. Our system should evolve with time in its analysis of the plant growth.
\end{itemize}
}

\section{Results and analysis}
\subsection{Machine learning environment}
Based on the data collected from the state of the art, two AI planning methods, requested to be able to take decisions that are maximizing the goal of the system at each time, have been retained: MDP and POMDP.
Both machine learning environments are observable. That is a need as the current state must characterize the processes of the system. The environment have also a probabilistic dynamic. As the system must chose between different actions based on the state that he faces, probabilistic dynamic is a must. Finally, the environment needs to have optimization as a goal, as the optimization of the well-being and height of the grown plant are the main objectives of the system. 
The difference between the two environments is the level of observability an thus the completeness of the current state's characterization of the process. 
At first, The MDP were chosen to be implemented. 
\\
\\
An MDP is a tuple (S, A, P, R, $\gamma$), where S is the state space, A a finite set of actions, P the state transition probability function, R the reward function and $\gamma$ is a discount factor ($\gamma$ ∈ [0, 1]) \cite{MDPcours}.
The MDP framework produces a policy that tells the right action to use from any situation in order to maximize the exploration gain while considering the uncertainty of the actions.


\subsection{States of our system, S}

A variable representing the days of growth (dog) is used. 
A first threshold ltresh is used. It corresponds to the lower limit of the plant greenness, below which the plant is considered to be dead and needs to be thrown away. 
A second threshold, htresh is adopted. At the opposite of ltresh, it marks the limit above which the plant is considered to be fully grown and ready to be harvested. 
The different states in which the plant can be are: 

\begin{itemize}
    \item level green > htresh
    \item level green > dog*a and < htresh
    \item level green < dog*a and > ltresh
    \item level green < ltresh
    \item end state
\end{itemize}
The other parameters of the system such as the temperature, water flow and PH level are not considered as defining a particular state in the first implementation of an MDP environment. 

\subsection{Actions, A}
The different actions that the system can perform are:
\begin{itemize}
     \item P1:"GO NEXT PLANT"
    \item P2:"TROW AWAY PLANT"
    \item P3:"HARVEST PLANT"
    \item W1:"INCREASE WATER FLOW"
    \item W2:"DECREASE WATER FLOW"
    \item N1:"INCREASE NUTRIENTS"
    \item N2:"DECREASE NUTRIENTS"
    \item L1:"INCREASE LIGHT"
    \item L2:"DECREASE LIGHT"
\end{itemize}

\subsection{Reward function}
The objective of the optimal strategy is to maximize the sum of all rewards. The objective of the robot is thus to bring the reward function to the highest value possible. Every action chosen to be taken by the robot is outlined by a particular reward value, linked to the well-being of the plant. This well being relates to: 
\begin{itemize}
    \item The size of the plant.
    \item The color (greenness) of the plant.
\end{itemize}
The goal of the robot is to make the plant grow while using the least amount of nutrients, water and light as possible. Thus, the reward decreases with the increase of the amount of water flowing, nutrients given and light increase, and increase when the opposite occurs. In order to lower the amount of nutrients used, the pump will be stopped when the plant is fed. Nutrients will be added manually and the light adjusted manually when requested. 

\subsection{Transition functions}
The use of MDP is characterized by the definition of transition functions. They define the probability distribution of the next system states $s_{t+1} ∈ S$ conditioned on each action: if a particular action $a_t ∈ A$ is selected by the agent, and the current system state is s, the next state $s_{t+1} ∈ S$ is reached with probability $p(s_{t+1} | s_t, a_t)$, with S all the states of the system and A all actions.

\subsection{Transition probabilities and expected rewards}

Two different approaches to the problem can be selected, one based on the detection of greenness of the plant, the other on the height of the plant. 
Both options' transition probabilities and expected rewards for the finite MDP can be seen in annex A.1 and A.2.
In the tables seen in the annexes, $\alpha$ and $\beta$ are both probability values to be determined.
A third option is to consider a combination of the two. 
\\
Figure \ref{fig:TransGraph} shows the transition graph corresponding to the first option. This option is the one chosen to be implemented in this report. 

\begin{figure}[h!]
    \centering
    \includegraphics[width=0.8\textwidth]{Images/Trans_graph.png}
    \caption{Transition graph}
    \label{fig:TransGraph}
\end{figure}
\noindent
The transition and state matrices have been computed using python coding. 

\subsection{Code}
The code implementing the MDP environment can been seen in the annex B. It is inspired of an existing code \cite{MDPcodee}. 
It consists in 6 different scripts, that together form the entire environment. 
\begin{itemize}
    \item The first script Actions, seen in annex B.1, specifies the actions that the system has at its disposition.
    \item The second script, States, that can be found in annex B.2, has functions that are used to decode the state that the system is in. For this first version of the implementation, missing the actual image recognition and sensors analysis, the states are implemented in the probability matrix P in the transition script.
    \item The third script, Transitions, shown in annex B.3, computes the probability matrix P and checks if it is correct.  
    \item The fourth script, Rewards, in annex B.4, computes the reward matrix R. Some specific values have been set, corresponding to actions that are beneficial to the overall goal of the system, which is to maximize the plant growing speed and well-being without consuming too much resources. 
    \item The fifth script is the MDP solver, seen in annex B.5. It has a first function IsPOk which checks if the matrix P is correct. The matrix is considered as ok if it is normalized. 
    The function NPValueIteration finds the optimal MDP policy and its value, using the method of value iteration.
    This method solves the non-linear Bellman Optimality Equation for V: 
    \begin{equation}
       V_*(s,a)=max_{a\in A} \sum_{s'\in S} P^a_{ss'} [R^a_{ss'}+\gamma*V_*(s',a')]
    \end{equation}
    Where V is the state-value function, R the reward matrix and P the probability matrix, s' and a' the other states and actions.
    \\
    \\
    Finally, the function NPComputesPolicy computes the optimal policy based on the state-value function solved previously. 
    \item The last script ValueItt, seen in annex B.6, runs an iteration on matrices of reward R and probability P.
\end{itemize}
 
The results of this code enable the system to know the best decision to take in every state. 
\subsection{Image recognition}

Real time information concerning the plant states needs to be accessed in order for the system to recognize its current state. The following subsection characterize the implementation of an image recognition algorithm responding to that demand. 

\noindent In order to make an adequate processing of the information (acquisition and transformation of the data), the image recognition device should be placed in a strategic position and its configuration should be programmed so as to suit the necessities of the growing system.\\

\noindent Therefore experiments with different arugula crops have been performed in an attempt to emulate the real conditions and find the best images recognition algorithm from those presented before in the state of the art. In the following sections each algorithm is explained in detail.

\subsubsection{Detection of the plant}

2 main objectives are to follow in order to correctly detect the plant:
\begin{itemize}
    \item Assure that the camera is taking images all the time.
    \item Classify if the image has a plant or not.
\end{itemize}
\\
\noindent The first goal has a straightforward meaning and the second one satisfies the condition of the color detection program.\\

\noindent Due to the fact that the color of the plant's substrate is within the RGB boundaries of a dry plant (stated with databases and observations), and the color algorithm is programmed taking into account these boundaries, if the image has not yet a plant (only the pot with the substrate), it will detect it as a dry plant. In that case a classification is needed to assure that the image has a plant in order to start with the color detection.\\

\noindent For both objectives, the selection of the most suitable image detection/classification pre-trained algorithm will meet with the following characteristics:

\begin{itemize}
    \item RAM consumption.
    \item Computation time.
    \item Accuracy of predictions.
\end{itemize}
\\

\noindent The most convenient algorithm satisfying these conditions is Overfeat, other pre-trained algorithms with the same database have been tested such as OpenCV, AlexNet, VGG16 or ResNet50. Nevertheless there were discarded because they all have a lower time of processing and accuracy than Overfeat. Appendix \ref{appendix:detection} shows these comparisons. \\

\noindent Following the selection of Overfeat, experiments have been carried out in order to assess its accuracy in terms of camera angles and light conditions, as seen in Appendix \ref{appendix:detection}.\\

\noindent Ensuing some tests, the conclusion for this first algorithm test is that the camera's best placement sport is in front of the plants at the level of the pot. The light incidence should be just on the top as stated in the growing system design part of the report.\\

\noindent Another conclusion, mentioned in Appendix \ref{appendix:detection}, is the need of a creation of a new database composed of the images that are to be taken using the final hydroponic prototype. It permits to train the classification algorithm and obtain a better accuracy. 


\subsubsection{Color detection}

The second image recognition algorithm is based on the level of greenness detection of the plant.

\noindent The classification algorithm will detect whether there is a plant on the pot (within the specific boundaries) and the image detection code will perform the corresponding actions. If no plant is seen, it will carry its analysis and wait until the plant is tall enough for the camera to recognize it.\\

\noindent Finally, the color detection algorithm must be capable of alerting the system when the plant has unacceptable conditions in terms of color, sending a value greater than a certain threshold, leading to a choice of the MDP based environment of the actions needed. \\

\noindent Aforementioned color detection algorithm was programmed using OpenCV, which is an open library which enable to solve computer vision problems\cite{OpenCV}. The reasons why this source was selected are the following:
\begin{itemize}
    \item OpenCV is free source.
    \item The community which contributes to this source is very large, so it has numerous modules that can be implemented.
    \item This library can be integrated with highly optimized libraries such as numpy for numerical operations, and therefore more optimized results.
\end{itemize}

\noindent OpenCV is used to detect the number of pixels which correspond to the dry part of the plant, the following steps have been executed on 2 plants: one fully-healthy grown and other one that is dry and needs more light in order be green.\\

\noindent At the beginning of the code, a prepossessing of the image has been performed due to some noisy background conditions that lead to a deficient recognition.\\

\noindent Based on this experience a second configuration for the final prototype is set. The cameras should be placed in a strategic position in order to avoid as much as possible focusing other objects which are not plants and also to take photos with a lot shadows (can eliminate part of a good plant).\\

\noindent Afterwards, some masks were applied to the images, these recalculate each pixel's value these ones according to a calculated matrix using BGR boundaries (founded by testings on the prototypes before mentioned), the following images display these images with the masks (See Appendix \ref{appendix:color} for the code performed):

\begin{figure}[h]
    \centering
    \includegraphics[width=0.6\textwidth,height=4cm ]{Images/1mask.png}
    \caption{1st mask applied, right figure semi-dry plant, left one healthy plant}
    \label{fig:figure8}
\end{figure}

\noindent This first mask was applied in order to clean the output from other objects for instance the pot & wall.\\

\begin{figure}[h]
    \centering
    \includegraphics[width=0.6\textwidth,height=4cm ]{Images/2mask.png}
    \caption{2nd mask applied, showing the "dry" parts of the plants}
    \label{fig:figure8}
\end{figure}

\noindent This second mask is applied in order to isolate the pixels which represent the dry parts of the plant.\\

\noindent Finally an acceptable percentage has been obtained and applied through different visual and computed experiments performed over different plants cases: plant completely dry or composed of at least one dry leaf (\textit{color brown approx}) , plant semi-dry (\textit{color between orange and yellow}) and healthy plant (\textit{color dark green}). These stack of 10 cases are illustrated in Appendix \ref{appendix:detection}. Also the python code used to perform this actions is shown in appendix \ref{appendix:color}\\

\noindent In summary, all testings over the plants were verified visually and compared within other plants. The comparison demonstrates that this method is accurate enough, as seen in the table below. Additionally an improvement can be applied by generating more specific RGB boundaries (which tell us the dry parts) such as growing more plants within the final hydroponic growing system.\\
\begin{table}[h]
\begin{center}
\hline
\begin{tabular}{|c|c|c|c|c|} 
Image No. & \% of plant dry & Accepted by program & Accepted visually & Plants comparison acc.\\
\hline
1 & 1.31\% & Yes & \cellcolor{green} Yes & \cellcolor{green} Yes \\
\hline
2 & 2.9 \% & No & \cellcolor{green} No & \cellcolor{green} Yes \\
\hline
3 & 1.32 \% & Yes & \cellcolor{green} Yes & \cellcolor{green} Yes\\
\hline
4 & 3.41 \% & No & \cellcolor{green} No & \cellcolor{green} Yes\\
\hline
5 & 0.76 \% & Yes & \cellcolor{green} Yes & \cellcolor{green} Yes\\
\hline
6 & 0.78 \% & Yes & \cellcolor{red} No & \cellcolor{red} No\\
\hline
7 & 1.5 \% & Yes & \cellcolor{green} Yes & \cellcolor{green} Yes\\
\hline
8 & 2.92 \% & No & \cellcolor{green} No & \cellcolor{green} Yes\\
\hline
9 & 4.12 \%  & No & \cellcolor{green} No & \cellcolor{green} Yes\\
\hline
10 & 1.13 \%  & Yes & \cellcolor{green} Yes & \cellcolor{green} Yes\\
\hline
\end{tabular}
\caption{Demonstration of OpenCV accuracy}
\end{center}
\end{table}\\

\noindent Taking into account these scores, the accuracy of the model is calculated. It is demonstrated that the solution works with 90\% of precision. This part of the program will be linked to the light sensor that will detect the exact light intensity in which the plants grow without any problem.

\subsubsection{Height detection}

Up to this point, precise algorithms have been created in order to analyze the current state a plant. In this section, the height of the plants is selected has the data to be measured. 
PH sensors and water flow sensors will allow us to compare pre-established values to have a healthy plant. A height sensor is proposed in order to have redundancy in the system and avoid any kind of error from the camera.\\

\noindent For this point the following solutions were proposed:\\

\begin{itemize}
    \item Place a scale behind the plant and place the camera on the other side just in front of them. In this case, chart image recognition can be used in order to detect the values that are visible on the camera's perspective. These values are the plant's height.
    \item The second one is to place one camera at the top of the plants and apply an area image detector. As the leafs appear larger in the images with the growth of the plan, a training of this algorithm could be possible with different heights of plants.
\end{itemize}

\noindent These 2 approaches were tested. The first method was retained. Indeed the second process was not accurate enough, lacking in precision. It also needed to be trained several times with a default height in order to arrive to an approximate solution.


\noindent The first method is computed using 2 libraries:
\begin{itemize}
    \item OpenCV: This library will be applied with the objective of making the pre-processing of the image.
    \item Python-tesseract, which is an optical character recognition (OCR) tool for python. It will recognize and read the text embedded in images \cite{pyte}, that can be compared visually with the scale that is placed behind the plant.
\end{itemize}

\noindent Experiments were performed using these tools on the crops mentioned before, obtaining acceptable results, as can be seen in the following images. The code can be consulted in Appendix \ref{appendix:heigth}.\\

\begin{figure}[h]
    \centering
    \includegraphics[width=0.3\textwidth,height=6cm ]{Images/prot1.PNG}
    \caption{Prototype #1, height 18 cm}
    \label{fig:figure8}
\end{figure}

\begin{figure}[h]
    \centering
    \includegraphics[width=0.4\textwidth,height=6cm ]{Images/prot2.PNG}
    \caption{Prototype #2, height 21 cm}
    \label{fig:figure8}
\end{figure}

\noindent Therefore, it can be concluded that this approach is sufficient to start with the first experiments handled with the hydroponic system. On top of that, after the realization of it, it was noticed that the camera position and size of image of each plant must be the same in every condition in order to obtain analyzable data. The background also plays a key roll in the detection process. A regular color background was chosen in order to facilitate the processing of the image.

\subsubsection{Image detection conclusions}

To summarize this subsection, the following tools have been selected in order to perform this recognition:

\begin{itemize}
    \item Overfeat for image detection and classification.
    \item OpenCV with python for color and height detection.
    \item Python-tesseract for height detection.
\end{itemize}

\noindent The following configurations must be taken into account during the realization of the final prototype:
\begin{itemize}
    \item The camera must be placed in-front of the plant at the level of the pot.
    \item Regular color background must be placed behind the plants.
    \item Light incidence must be over the plants for a better accuracy.
    \item Camera must focus as much as possible only the plant, to avoid detection of other objects.
    \item Arugula datasets of internet can be used to obtain growing parameters, however for image recognition is better to have databases from the real experiment.
    \item All the pots must have the same configurations to avoid any kind of error during the compilation of the programs.
\end{itemize}

\noindent It is proposed to create a training model based on the images of the real experiment in order to create methods/models based on machine learning and have a completely autonomous system at the end of the project, such as: 
\begin{itemize}
    \item Tensorflow for image detection and classification
    \item Surface/Volume estimation/prediction for the height
\end{itemize}

\noindentAll All experiments performed can be consulted in the repository of the project Greenhouse on Mars.
\newpage
\section{Conclusion and perspectives}
\begin{comment}
The aim of this section is to answer the following question:
What are the main achievements?
What will I do next semester?
The degree of novelty has to be pointed out
\\
\\
Restate the thesis by making the same point with other words (paraphrase).
Review your supporting ideas.
For that, summarize all arguments by paraphrasing how you proved the thesis.
Connect back to the essay hook and relate your closing statement to the opening one.
Combine all the above to improved and expanded conclusion.
\end{comment}

Through the invention of an autonomous indoor agriculture prototype, this project addresses a solution to the two priorities of present and future space missions: the reduction of workload on crews and the issue of food supply.
\\
\\
A state of the art of indoor vegetable growing systems, automation of system, machine learning strategies and image recognition has been established. Based on the information gleaned, the different methods best suiting the project's purposes have been selected. 
\\
\\
The proposed model applies the concept of hydroponics on arugula. The hydroponic process uses less resources and area than common soil based agriculture. Saving space, optimizing resources, maximizing the plants' well being and having a low time of growth, the solution matches all imposed criteria. The constitution of a plan of the model preceded the command of the different components. 
The hydroponic prototype, of 2 meters squared, is equipped of an arm robot, a camera as well as water flow, temperature and PH sensors. The robot is placed on a movable platform, enabling it to reach the plants spread all around the model. 
\\
\\
The machine learning environment selected to bring artificial intelligence to the system is based on a Markov Decision Process (MDP) environment, of which a first version has been implemented using python. This MDP takes information from data collected by the camera. This data is collected and analyzed using an image recognition algorithm, also implemented in python. 
\\
\\
The use of both image recognition and MDP together to implement an hydroponic system is a great solution that could prove to be helpful to ongoing research project of both the the Nasa and ESA. It could also prove to be the start of an entire new era of agriculture processes, enabling every human, already born or yet to discover the world, to eat their fill.
\\
\\
During semester 3, the project will focus on building the prototype and test the MDP and image recognition's python codes, to arrive to a final implementation of the test growing strategy.
An optimization of the MDP implementation will be made, increasing the number of possible states known to the system and thus maximizing the MDP's efficiency.
Following the realization of a efficient prototype, the second stage of the project will begin. A larger variety of plants will be tested and a reserve tank will be added to the reservoir, combined with the increase of analyzable data. 
Then will follow the realization of the third stage of the project. This last stage will consist in the isolation of the entire system from ambient condition and in the individual enlightenment of each plant. It will mark the end of the project.
\\
\\
What stood off during the first semester of realization of the project is the agricultural efficiency potential that bear aeroponics systems. This process as been considered as too difficult to implement and needed too much funding to see the light, but could be the best solution for the future of agriculture as its resources consumption is even lower then hydroponics and growth faster. The complexity of the system is what drives off most of the researchers but it is a concept worth a deep study.

\newpage
\section{References}
\phantomsection 
\printbibliography
\newpage
\begin{appendices}
\section{Transition probabilities and expected rewards for the finite MDP}
\subsection{Based on the plant's greenness}
\begin{tabular}{|p{4.9cm}|p{4.9cm}|p{3cm}|p{1.2cm}|p{1.5cm}|}
 \hline
 \multicolumn{5}{|c|}{Global system} \\
 \hline
 s_t & s' = s_{t+1} & a=a_t & P^{a}_{ss'} & R^{a}_{ss'}\\
 \hline
 level green $>dog*a \ \& <htresh (\%) $ & level green $>dog*a \ \& <htresh (\%) $ & go to next plant &  1 & R_{(+)}^{Next}\\
 
 level green $>dog*a \ \& <htresh (\%) $ & level green $>dog*a \ \& <htresh (\%) $ & reduce water flow & \alpha & R_{(+)}^{RedWat}\\
 level green $>dog*a \ \& <htresh (\%) $ & level green $<dog*a \ \& >ltresh (\%) $ & reduce water flow & \beta & R_{(+)}^{RedWat}\\
 level green $>dog*a \ \& <htresh (\%) $ & level green $>htresh (\%) $ & reduce water flow & 1-\alpha-\beta & R_{(+)}^{RedWat}\\
 
 level green $>dog*a \ \& <htresh (\%) $ & level green $>dog*a \ \& <htresh (\%) $ & reduce light flow & \gamma & R_{(+)}^{RedLight}\\
 level green $>dog*a \ \& <htresh (\%) $ & level green $<dog*a \ \& >ltresh (\%) $ & reduce light flow & \delta & R_{(+)}^{RedLight}\\
 level green $>dog*a \ \& <htresh (\%) $ & level green $>htresh (\%) $ & reduce light flow & 1-\gamma-\beta & R_{(+)}^{RedLight}\\
 
 level green $>dog*a \ \& <htresh (\%) $ & level green $>dog*a \ \& <htresh (\%) $ & reduce nutrients & \epsilon & R_{(+)}^{RedNut}\\
 level green $>dog*a \ \& <htresh (\%) $ & level green $<dog*a \ \& >ltresh (\%) $ & reduce nutrients & \zeta & R_{(+)}^{RedNut}\\
 level green $>dog*a \ \& <htresh (\%) $ & level green $>htresh (\%) $ & reduce nutrients & 1-\epsilon-\zeta & R_{(+)}^{RedNut}\\  
 
 
 
 level green $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase water flow & \eta & R_{(-)}^{IncWat}\\
 level green $<dog*a (\%) \ \& > ltresh$ & level green $>dog*a (\%) \ \& > ltresh$ & increase water flow &  \theta & R_{(-)}^{IncWat}\\
 level green $<dog*a (\%) \ \& > ltresh$ & level green $< ltresh$ & increase water flow & 1-\eta-\theta & R_{(-)}^{IncWat}\\
 
 level green $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase light & \iota & R_{(-)}^{Inclight}\\
 level green $<dog*a (\%) \ \& > ltresh$ & level green $>dog*a (\%) \ \& < htresh$ & increase light & \kappa & R_{(-)}^{Inclight}\\
 level green $<dog*a (\%) \ \& > ltresh$ & level green $< ltresh$ & increase light & 1-\iota-\kappa & R_{(-)}^{Inclight}\\
 
 level green $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase nutrients & \lambda & R_{(-)}^{IncNut}\\
 level green $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase nutrients & \mu & R_{(-)}^{IncNut}\\
 level green $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase nutrients & 1-\lambda-\mu & R_{(-)}^{IncNut}\\
 
 level green $>htresh (\%) $ & level green $>htresh (\%) $ & harvest plant & 1 & R_{(+)}^{Harv}\\
 level green $<ltresh (\%) $ & level green $lhtresh (\%) $ & throw away plant & 1 & R_{(+)}^{Harv}\\
 
\hline
\end{tabular}
\subsection{Based on the plant's height}
\begin{tabular}{|p{4.9cm}|p{4.9cm}|p{3cm}|p{1.2cm}|p{1.5cm}|}
 \hline
 \multicolumn{5}{|c|}{Global system} \\
 \hline
 s_t & s' = s_{t+1} & a=a_t & P^{a}_{ss'} & R^{a}_{ss'}\\
 \hline
 height $>dog*a \ \& <htresh (\%) $ & level green $>dog*a \ \& <htresh (\%) $ & go to next plant &  1 & R_{(+)}^{Next}\\
 
 height $>dog*a \ \& <htresh (\%) $ & level green $>dog*a \ \& <htresh (\%) $ & reduce water flow & \alpha & R_{(+)}^{RedWat}\\
 level green $>dog*a \ \& <htresh (\%) $ & level green $<dog*a \ \& >ltresh (\%) $ & reduce water flow & \beta & R_{(+)}^{RedWat}\\
 height $>dog*a \ \& <htresh (\%) $ & level green $>htresh (\%) $ & reduce water flow & 1-\alpha-\beta & R_{(+)}^{RedWat}\\
 
 height $>dog*a \ \& <htresh (\%) $ & level green $>dog*a \ \& <htresh (\%) $ & reduce light flow & \gamma & R_{(+)}^{RedLight}\\
 height $>dog*a \ \& <htresh (\%) $ & level green $<dog*a \ \& >ltresh (\%) $ & reduce light flow & \delta & R_{(+)}^{RedLight}\\
 height $>dog*a \ \& <htresh (\%) $ & level green $>htresh (\%) $ & reduce light flow & 1-\gamma-\beta & R_{(+)}^{RedLight}\\
 
 height $>dog*a \ \& <htresh (\%) $ & level green $>dog*a \ \& <htresh (\%) $ & reduce nutrients & \epsilon & R_{(+)}^{RedNut}\\
 height $>dog*a \ \& <htresh (\%) $ & level green $<dog*a \ \& >ltresh (\%) $ & reduce nutrients & \zeta & R_{(+)}^{RedNut}\\
 height $>dog*a \ \& <htresh (\%) $ & level green $>htresh (\%) $ & reduce nutrients & 1-\epsilon-\zeta & R_{(+)}^{RedNut}\\  
 
 
 
 height $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase water flow & \eta & R_{(-)}^{IncWat}\\
 height $<dog*a (\%) \ \& > ltresh$ & level green $>dog*a (\%) \ \& > ltresh$ & increase water flow &  \theta & R_{(-)}^{IncWat}\\
 height $<dog*a (\%) \ \& > ltresh$ & level green $< ltresh$ & increase water flow & 1-\eta-\theta & R_{(-)}^{IncWat}\\
 
 height $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase light & \iota & R_{(-)}^{Inclight}\\
 height $<dog*a (\%) \ \& > ltresh$ & level green $>dog*a (\%) \ \& < htresh$ & increase light & \kappa & R_{(-)}^{Inclight}\\
 height $<dog*a (\%) \ \& > ltresh$ & level green $< ltresh$ & increase light & 1-\iota-\kappa & R_{(-)}^{Inclight}\\
 
 height $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase nutrients & \lambda & R_{(-)}^{IncNut}\\
 height $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase nutrients & \mu & R_{(-)}^{IncNut}\\
 height $<dog*a (\%) \ \& > ltresh$ & level green $<dog*a (\%) \ \& > ltresh$ & increase nutrients & 1-\lambda-\mu & R_{(-)}^{IncNut}\\
 
 height $>htresh (\%) $ & level green $>htresh (\%) $ & harvest plant & 1 & R_{(+)}^{Harv}\\
 height $<ltresh (\%) $ & level green $lhtresh (\%) $ & throw away plant & 1 & R_{(+)}^{Harv}\\
 
\hline
\end{tabular}
\newpage
\section{MDP environment Code}
\subsection{Actions script}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.7\textwidth]{Images/Actions.png}
    \caption{Actions script}
    \label{fig:actions}
\end{figure}
\subsection{States script}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{Images/states1.png}
    \caption{Actions script: part 1}
    \label{fig:states1}
\end{figure}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{Images/States2.png}
    \caption{Actions script: part 2}
    \label{fig:states2}
\end{figure}
\subsection{Transitions script}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{Images/Trans1.png}
    \caption{Transitions script: part 1}
    \label{fig:trans1}
\end{figure}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{Images/Trans2.png}
    \caption{Transitions script: part 2}
    \label{fig:trans2}
\end{figure}
\subsection{Rewards script}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{Images/rew1.png}
    \caption{Rewards script: part 1}
    \label{fig:rew1}
\end{figure}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{Images/rew2.png}
    \caption{Rewards script: part 2}
    \label{fig:rew2}
\end{figure}
\subsection{MDP solver script}  
\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{Images/MDP1.png}
    \caption{MDP solver script: part 1}
    \label{fig:MDP1}
\end{figure}
\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{Images/MDP2.png}
    \caption{MDP solver script: part 2}
    \label{fig:MDP2}
\end{figure}
\subsection{Value iteration script}  
\begin{figure}[H]
    \centering
    \includegraphics[width=0.9\textwidth]{Images/valitt.png}
    \caption{Value iteration script}
    \label{fig:MDP1}
\end{figure} 
\newpage
\section{Detection algorithms}
\label{appendix:detection}


\noindent The first step was to find all the list of the best algorithms detectors and classifiers, and according to some research the following top 5 were founded according to ImageNet competitions: AlexNet, VGG19, VGG16, ResNet50 and Overfeat. \\

\noindent In the following it is shown the comparison between VGG16 and Overfeat, which had the top ranks according to the tests performed, this has been applied into 10 images taken in the same angle in front of them and these were from different plant sizes:\\

\begin{figure}[h]
    \centering
    \includegraphics[width=0.9\textwidth,height=7cm ]{Images/VGG16.PNG}
    \caption{VGG16 results, Front view, accuracy 48\%, RAM used: 922.43 MB}
    \label{fig:app31}
\end{figure}


\begin{figure}[h]
    \centering
    \includegraphics[width=0.9\textwidth,height=7cm ]{Images/Overfeat.PNG}
    \caption{Overfeat results, Front view, accuracy 83.33\%, RAM used: 10.25228 MB}
    \label{fig:app32}
\end{figure}

\\

\noindent In conclusion the VGG16 algorithm decrease its accuracy conforming the size of the plant is less, if it is not big enough the algorithm detects something else (eg. paper towel, hook, etc), and there is a huge increase of RAM usage for VGG16, respect the computation time the time is almost the same, therefore the most suitable algorithm is Overfeat.\\

\noindent After this selection, here below it shown the angle in which the camera should be placed, in order to detect the input that we want to obtain with an appropriate precision, some other were tested such as on the top or on the top with an angle (top accuracy is shown in the second image), but the one with the most accuracy it is shown below (the accuracy is shown in the previous image of Overfeat):

\begin{figure}[h]
    \centering
    \includegraphics[width=0.9\textwidth,height=7cm ]{Images/images.png}
    \caption{Extract of 10 images for the test}
    \label{fig:app33}
\end{figure}

\begin{figure}[h]
    \centering
    \includegraphics[width=0.9\textwidth,height=7cm ]{Images/TOPVIEW.png}
    \caption{Top view accuracy of 30\%}
    \label{fig:app34}
\end{figure}

\noindent \textbf{Note:} As seen on the predictions of the images these do not predict plants by itself, since the weight of Overfeat is taken from ImageNet, and these images are not in the database, hence it is proposed to create a new database based on the images taken by the camera of our hydroponic growing system in order to train the classifier and have an even better accuracy.
\newpage

\subsection{Python codes to use classification algorithms}
\begin{figure}[h]
    \centering
    \includegraphics[width=0.9\textwidth,height=7cm ]{Images/Overfeat_class.PNG}
    \caption{Python code for Overfeat classification}
    \label{fig:app35}
\end{figure}
\begin{figure}[h]
    \centering
    \includegraphics[width=0.9\textwidth,height=7cm ]{Images/VGG16_class.PNG}
    \caption{Python code for remaining models (VGG16, VGG19, AlexNet}
    \label{fig:app36}
\end{figure}
\newpage
\section{Color detection python code}
\label{appendix:color}
\begin{figure}[h]
    \centering
    \includegraphics[width=0.6\textwidth,height=5cm ]{Images/color_code_1.PNG}
    \caption{Reading and editing image}
    \label{fig:app37}
\end{figure}

\begin{figure}[h]
    \centering
    \includegraphics[width=0.7\textwidth,height=5cm ]{Images/color_code_2.PNG}
    \caption{Application of cleaning mask to isolate plant}
    \label{fig:app38}
\end{figure}

\begin{figure}[h]
    \centering
    \includegraphics[width=0.6\textwidth,height=4.7cm ]{Images/color_code_3.PNG}
    \caption{Application of second mask to extract the dry parts of the plant}
    \label{fig:app39}
\end{figure}

\begin{figure}[h]
    \centering
    \includegraphics[width=0.7\textwidth,height=5cm ]{Images/color_code_4.PNG}
    \caption{Calculating the dry percentage of the plant with respect to the total pixels}
    \label{fig:app40}
\end{figure}

\newpage

\section{Height detection python code}
\label{appendix:heigth}

\begin{figure}[h]
    \centering
    \includegraphics[width=0.6\textwidth,height=4cm ]{Images/h_code.PNG}
    \caption{OCR python code, pre-processing of the image}
    \label{fig:app41}
\end{figure}

\begin{figure}[h]
    \centering
    \includegraphics[width=0.6\textwidth,height=5cm ]{Images/h_code_2.PNG}
    \caption{OCR python code, detection pos-processing}
    \label{fig:app42}
\end{figure}


\end{appendices}

\begin{section}
Commentaries by Nicolas

-Better explanation of the appendixes, usage of formulas, etc.... 
\\
\\
-Gaby: used a threshold, work on the values. Try to minimize error (= training) and when error, use different data. Trheshold non specified, fix the value based on the data. More no if higher, less if lower. -> find a good value. Differentiate training set and testing set. What to put in the training and testing set. Testing set used to compute the value of the threshold. Strange that it works that well. 
Used the testing set to train, not allowed. 
\\
\\
Plant greeness: percentage of green pixels. Plot the green and dry pixels on a graph. And then extract features. 
\\
\\
Another improvement: take a lot of pictures to reduce the error. Error reduced: P(eatable)= Yes/nbr + No/nbr
\\
\\
Precision agriculture: keyword
\\
\\
We could have used another way: simulator to use reinforcement learning: sarsa and q learning. Transition function not specified. 

Value iteration: Transition function is known + solve using MDP solver

Here, we know the transition function. -> value iteration good solver.

Overleaf: deep learning algorithm. We cnat use it because we dont have a big dataset. it is feature extraction only for the algorithm.

Adrien planning not machine learning strategy
Gaby machine learning

PH, lower case p

in the figure, in Figure

AI based system, what the system is using is inputs 

outputs equals actions

POMP is partially observable

GO mext plant 

discretisation

transition graph not clear

manually, change it

reward, if cost too high, prefer not to do anything

maybe use only well being of the plant but put a threshold on the energy 


assure that the camera is taking pictures all the time, working well

Lower and higher time of processing
Precise this kind of informaion qith a table

Many pictures with many observations''
Probabilty of observation

P9**((Obervation)
Majority of observations with formulas, 
Calcute 
You take the answer of mistkar
Majority vote
Change the angle of the camera independce between the answer

tomar foto en diferentes angulos hasta que te de la respuesta que estes buscando, el majority vote

cardinality (number of) of the set 

Indepence of the data that is reliable and makes your algorithm more correct 

Argument 

You can reuse the dataset, you can label it simply from scracth, just watching it (in machine learning language)

parse shapes 
pretrained algorithms
scene parsing (deep learning)
PSPnet (that sees the shapes) to stimate the height 
scene parsing deep learning 
recompute the angle of the error of the angle the 

construct as the color different observations with different plants and take el numero más alto

rasberry and arduino 

yuu didnt tune the threshold with this data



Majority boot

\end{section}
\end{document}
